#class auto
#nodebug
//==================================================================
//
//  Generic Header information generated by 13705CFG.EXE (Build 9)
//
//  Copyright (c) 2000,2001 Epson Research and Development, Inc.
//  All rights reserved.
//
//  Panel: 320x240x8bpp 113Hz Color 8-Bit STN, Format 2 (PCLK=20.000MHz)
//
//  This file defines the configuration environment and registers,
//  which can be used by any software, such as display drivers.
//
//  PLEASE NOTE: If you FTP this file to a non-Windows platform, make
//               sure you transfer this file using ASCII, not BINARY
//               mode.
//
//==================================================================

#define S1D_DISPLAY_WIDTH               320
#define S1D_DISPLAY_HEIGHT              240
#define S1D_DISPLAY_BPP                 4
#define S1D_DISPLAY_SCANLINE_BYTES      160
#define S1D_DISPLAY_FRAME_RATE          113
#define S1D_DISPLAY_PCLK                20000000L
#define S1D_PHYSICAL_REG_ADDR           0x0002FFE0L
#define S1D_PHYSICAL_VMEM_ADDR          0x00010000L
#define S1D_PHYSICAL_REG_SIZE           31L
#define S1D_PHYSICAL_VMEM_SIZE          81920L
#define S1D_PALETTE_SIZE                256
#define S1D_FRAME_RATE                  113
#define S1D_POWER_DELAY_OFF             500
#define S1D_POWER_DELAY_ON              0
#define S1D_REGDELAYOFF                 0xFE
#define S1D_REGDELAYON                  0xFF

typedef unsigned char S1D_INDEX;
typedef unsigned char S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

const static S1D_REGS aS1DRegs[] =
{
    { 0x00,             0x24 },       // Revision Code Register
    { 0x01,             0x3B },       // Mode Register 0 Register
    { 0x02,             0xD0 },       // Mode Register 1 Register
    { 0x03,             0x03 },       // Mode Register 2 Register (enable display)
    { 0x04,             0x27 },       // Horizontal Panel Size Register
    { 0x05,             0xEF },       // Vertical Panel Size Register (LSB)
    { 0x06,             0x00 },       // Vertical Panel Size Register (MSB)
    { 0x07,             0x1F },       // FPLINE Start Position Register
    { 0x08,             0x00 },       // Horizontal Non-Display Period Register
    { 0x09,             0x00 },       // FPFRAME Start Position Register
    { 0x0A,             0x0B },       // Vertical Non-Display Period Register
    { 0x0B,             0x00 },       // MOD Rate Register
    { 0x0C,             0x00 },       // Screen 1 Start Address Register (LSB)
    { 0x0D,             0x00 },       // Screen 1 Start Address Register (MSB)
    { 0x0E,             0x00 },       // Screen 2 Start Address Register (LSB)
    { 0x0F,             0x00 },       // Screen 2 Start Address Register (MSB)
    { 0x10,             0x00 },       // Screen Start Address Overflow Register
    { 0x11,             0x00 },       // Memory Address Offset Register
    { 0x12,             0xFF },       // Screen 1 Vertical Size Register (LSB)
    { 0x13,             0x03 },       // Screen 1 Vertical Size Register (MSB)
    { 0x18,             0x00 },       // GPIO Configuration Control Register
    { 0x19,             0x02 },       // GPIO Status/Control Register
    { 0x1A,             0x00 },       // Scratch Pad Register
    { 0x1B,             0x00 },       // SwivelView Mode Register
    { 0x1C,             0xA0 },       // Line Byte Count Register
};
#define S1DNUMREGS 25
#define S1DREGOFFSET 0x1FFE0
#define S1DMEMSIZE 76800

typedef union {
	unsigned char RGB[3];
} triplet;


#define S1D_WRITE_PALETTEi(i,r,g,b)  \
  {  \
  write13705(S1DREGOFFSET+0x15,i); \
  write13705(S1DREGOFFSET+0x17,r); \
  write13705(S1DREGOFFSET+0x17,g); \
  write13705(S1DREGOFFSET+0x17,b); \
  }

#define S1D_READ_PALETTEi(i,r,g,b)   \
  {  \
  write13705(S1DREGOFFSET+0x15,i); \
  r = read13705(S1DREGOFFSET+0x17); \
  g = read13705(S1DREGOFFSET+0x17); \
  b = read13705(S1DREGOFFSET+0x17); \
  }



/* VERSIONS FOR LONG ADDRESS */

#asm root
read13705:
		call addressbus		; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld hl,PBDR				; apunta a port paralelo
      ioi res 7,(HL)			; baja RD
rwait:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,rwait				; espera hasta que NOWAIT
      ioi ld a,(PADR) 		; lee dato
      ioi set 7,(HL)			; sube RD
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ld h,0
      ld l,a
      ret

;sp+2: A0-A15
;sp+4: A16
;sp+6: data
write13705::
		call addressbus		; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld hl,(sp+6)			; lee dato
      ld a,l
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait				; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS (en shadow)
      ld a,0x80
      ioi ld (SPCR),a		; A= entradas
      ret

;sp+2: return address for calling function
;sp+4: A0-A15
;sp+6: A16
;sp+8: data
addressbus:
		ld hl,(sp+4)			; lee address
      ex de,hl					; en DE
		ld hl,(sp+6)			; lee address A16
      ld a,l					; en A
ab2:	ld hl,PEDR				; apunta a port
		ioi ld (hl),d			; pone parte alta
		ld hl,PDDR				; apunta a port
		ioi ld (hl),e			; pone parte baja
		ld hl,PCDR				; apunta a port paralelo
		ioi set 0,(hl)			; BHE=1
		rrc e						; debo activar BHE ? (test LSB=1)
		jr nc,ok1	  			; no
      ioi res 0,(HL)			; s, BHE=0
ok1:
		ioi set 4,(hl)			; PE.1 FIX, REMOVE LATER
		bit 1,d					; PE.1 FIX, REMOVE LATER
		jr nz,ok2 				; PE.1 FIX, REMOVE LATER
      ioi res 4,(HL)	 		; PE.1 FIX, REMOVE LATER
ok2:
      ioi res 6,(HL)			; A16=0
		rrca						; A16=1 ?
		jr nc,ok3	  			; no
      ioi set 6,(HL)			; s, A16=1
ok3:
		ret


;IY: A0-A15
;A: A16
;(IX+0): data left
;(IX+1): data right
writew13705::
		ld a',a					; save A16
		ld hl,iy					; get A15-A0
      ex de,hl					; in DE
		call ab2					; put addresses and BHE
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld a,(IX+0)				; lee dato
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait1:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait1			; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ex af,af'				; restore A16
		ld hl,iy					; lee address
		ld	de,0x0001			; next byte
		add hl,de				; inc address
		adc a,d	  				; (adc a,0x00) propagate carry
      ex de,hl					; A15-A0 in DE
		ld a',a					; save A16
      call ab2					; address bus
		ld hl,PCDR				; apunta a port paralelo
      ioi res 2,(HL)			; baja CS
		ld a,(IX+1)				; lee dato
      ioi ld (PADR),a		; pone dato
      ld a,0x84
      ioi ld (SPCR),a  		; A= salidas
		ld hl,PBDR				; apunta a port paralelo
      ioi res 6,(HL)			; baja WE0
wwait2:
      ioi ld a,(hl)			; lee port paralelo
      rrca						; chequea bit 0 (WAIT)
      jr nc,wwait2			; espera hasta que NOWAIT
      ioi set 6,(HL)			; sube WE0 (must be >1/BCLK after NOWAIT)
		ld hl,PCDR				; apunta a port paralelo
      ioi set 2,(HL)			; sube CS
      ld a,0x80
      ioi ld (SPCR),a		; A= entradas
      ex af,af'				; restore A16
      ret

xdumpblk::
		ld		a,xpc								; save the frame pointer, and xpc
		push	af
		push	ix

		ld		de,0xe000						; de=lsw(dest)-0xe000
		ld		hl,(sp+10)
		or		a
		sbc	hl,de
		ex		de,hl
		ld		hl,(sp+11)						; hl:e=(dest-0xe000)>>8
		jr		nc,.xcbf_1
		dec	h
.xcbf_1:
		ld		l,d

		add	hl,hl								; h=(dest-0xe000)>>12
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld		a,h
		ld		xpc,a								; xpc=(dest-0xe000)>>12

		ex		de,hl								; calculate the offset in xpc window
		ld		a,h								;    ix=(dest&0x0fff)|0xe000
		and	0x0f
		or		0xe0
		ld		h,a
		ld		ix,hl

		ld		iy,(sp+6)						; a:iy=dest, hl=length
		ld		hl,(sp+8)
		ld		a,l
		ld		hl,(sp+14)

		ld		c,h								; c:b=length
		ld		b,l
		ex		af,af'
		ld		a,l
		or		a
		jr		nz,.xcbf_2
		dec	c
.xcbf_2:
		ex		af,af'

xcbf_loop:
      call	writew13705						; preserve BC,IX,IY,A
		ld		de,0x0002						; 6 copying word by word
		add	ix,de								; 4
		add	iy,de								; 4
		adc	a,d								; 2, (adc a,0x00) propagate carry
		djnz	xcbf_loop						; 5, critical path word
		dec	c
		jp		p,xcbf_loop

xcbf_done:
		pop	ix
		pop	af
		ld		xpc,a
		ret
#endasm


void writepalette(triplet *address)
{
int i;
unsigned char *ptr;

	ptr=&(address->RGB[0]);
  	write13705(0x15+S1DREGOFFSET,0);
	for(i=0;i<256;i++){
     write13705(S1DREGOFFSET+0x17,*ptr++);
	  write13705(S1DREGOFFSET+0x17,*ptr++);
	  write13705(S1DREGOFFSET+0x17,*ptr++);
   }
}


void init13705()
{
int i;

	for(i=1;i<S1DNUMREGS;i++)
   	write13705((aS1DRegs[i].Index)+S1DREGOFFSET,aS1DRegs[i].Value);
}

void LCD_fill(unsigned long address, unsigned long len, unsigned char color)
{
	while(len--)
     	write13705(address++,color);						// fill with color
}

#define LCD_clear() LCD_fill(0L,S1DMEMSIZE,0)


/* Plot image data, 1 pixel per byte, MSB left */

#define LCD_plot(x,y,color) write13705(320L*y+x,color)



root useix void LCD_dump(long imgdata, triplet *paldata)
{

long dest;
unsigned int tocopy,len;


	len=S1DMEMSIZE/2;
   dest=0;
   imgdata+=sizeof(long);
   writepalette(paldata);
		while(len) {
			tocopy=2048-(int)(dest&2047);
			if(tocopy>len)
				tocopy=len;
			xdumpblk(dest,imgdata,tocopy);
			dest+=(tocopy<<1);
			imgdata+=(tocopy<<1);
			len-=tocopy;
		}

}

// Bresenham Line Algorithm

void LCD_line(int x1,int y1,int x2,int y2, unsigned char color)
{
int  x,y,dx,dy,incx,incy,balance;

        if (x2 >= x1){
                dx = x2 - x1;
                incx = 1;
        }
        else {
                dx = x1 - x2;
                incx = -1;
        }

        if (y2 >= y1) {
                dy = y2 - y1;
                incy = 1;
        }
        else {
                dy = y1 - y2;
                incy = -1;
        }

        x = x1;
        y = y1;

        if (dx >= dy) {
                dy <<= 1;
                balance = dy - dx;
                dx <<= 1;

                while (x != x2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                y += incy;
                                balance -= dx;
                        }
                        balance += dy;
                        x += incx;
                }
                LCD_plot(x, y,color);
        }
        else {
                dx <<= 1;
                balance = dx - dy;
                dy <<= 1;

                while (y != y2) {
                        LCD_plot(x, y,color);
                        if (balance >= 0) {
                                x += incx;
                                balance -= dy;
                        }
                        balance += dx;
                        y += incy;
                }
                LCD_plot(x, y,color);
        }
}


#define LCD_rectangle(x1,y1,x2,y2,c) \
{ \
	LCD_line(x1,y1,x2,y1,c); \
	LCD_line(x2,y1,x2,y2,c); \
	LCD_line(x2,y2,x1,y2,c); \
	LCD_line(x1,y2,x1,y1,c); \
}


#use "6X8L.lib"
#use "12X16L.lib"

typedef struct {
	unsigned long *font;
	unsigned char	lpc;           // lines per character
	unsigned char	Bpcl;          // bytes per character line (1 or 2)
	unsigned char	bpcl;          // bits per character line
} FontInfo;

const static FontInfo fontinfo[]={
{&Font6x8,8,1,6},
{&Font12x16,16,2,12}
};

void LCD_putchr ( int font, unsigned long daddress, char chr , int color, int bcolor)
{
int i,j,ii,jj;
unsigned long address,dispaddress;
int data,aux;

	i=fontinfo[font].lpc;			// lines per character
	ii=fontinfo[font].Bpcl;			// bytes per character line
   jj=fontinfo[font].bpcl;			// bits per character line
	address=*(fontinfo[font].font)+i*ii*(chr-0x20);
   dispaddress=daddress;
	while(i--){
   	data=xgetint(address);
		aux=(data&0xFF)<<8;			// swap bytes
      data=((data>>8)&0xFF)+aux;
      address+=ii;
      j=jj;
      while(j--){
			if(data&0x8000)
				write13705(dispaddress,color);
      	else
         	if(bcolor>=0)				// bcolor =-1 => transparent
					write13705(dispaddress,bcolor);
         data<<=1;
         dispaddress++;
      }
	   dispaddress=daddress+=320;	// next line
	}
}

void LCD_printat (int font, unsigned int row, unsigned int col, char *ptr, int color, int bcolor)
{
unsigned long address;

  	address=320L*row;
	do {
   	address+=col;
		LCD_putchr (font,address,*ptr++,color,bcolor);
      col=fontinfo[font].bpcl;
	} 	while (*ptr);
}



void MsDelay ( int iDelay )
{
	unsigned long ul0;
	ul0 = MS_TIMER;		// get current timer value
	while ( MS_TIMER < ul0 + (unsigned long) iDelay );
}


main()
{
unsigned int i,j;

  	WrPortI ( SPCR, &SPCRShadow, 0x80 );		// PA0-7 = Inputs
	WrPortI ( PEDDR,&PEDDRShadow,'\B11111111' );
	WrPortI ( PDDDR,&PDDDRShadow,'\B11111111' );
	WrPortI ( PBDR,&PBDRShadow,'\B11000000' );
	WrPortI ( PCDR,&PCDRShadow,'\B11111111' );
	WrPortI ( PCFR,&PCFRShadow,0 );				// disable prog port (use PC6)

	init13705();
  	write13705(0x15+S1DREGOFFSET,0);
	for(i=0;i<256;i++){
     write13705(S1DREGOFFSET+0x17,i&0xE0); 			// rrrggbbb -> rrr0 0000
	  write13705(S1DREGOFFSET+0x17,(i<<3)&0xC0);		//					gg00 0000
	  write13705(S1DREGOFFSET+0x17,(i<<5)&0xE0);		//					bbb0 0000
   }
	LCD_clear();
	LCD_rectangle(10,5,128,45,0x60);
	LCD_rectangle(8,3,130,47,0x3);
	LCD_printat(0,20,20,"Cika Electronica",0xFF,0x34);
}

